/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <project.h>
#include "stdio.h"
#include "myUART.h"

uint8 uart_rx_buffer[UART_BUFFER_SIZE*2];
uint8 * uart_rx_readPT = uart_rx_buffer;
uint8 * uart_rx_writePT = uart_rx_buffer;
int uart_msg = 0;

CY_ISR(isr_rx_handler)
{
    *uart_rx_writePT = UART_GetChar();
    
    if((*uart_rx_writePT == '\r')||(*uart_rx_writePT == '\n'))
    {
        *uart_rx_writePT = 0;
        uart_msg++;
    }
    
    uart_rx_writePT++;
    if(uart_rx_writePT >= &uart_rx_buffer[UART_BUFFER_SIZE]) uart_rx_writePT=uart_rx_buffer;

}

void myUart_start(void)
{
    UART_Start();
//    isr_rx_StartEx(isr_rx_handler);
    setbuf(stdout, NULL);
}
//in progress, misschien is het gewoon beter om de hele functie naar de buffer te brengen
int myUart_proces(uint8* buffer)
{
    
    //enkel doen als er een bericht is
    if(uart_msg > 0)
    {

        while(*uart_rx_readPT!=0)
        {
            *buffer = *uart_rx_readPT;
            uart_rx_readPT++; buffer++;
            if(uart_rx_readPT >= &uart_rx_buffer[UART_BUFFER_SIZE]) 
            {
                uart_rx_readPT = uart_rx_buffer;
            }
            
        }
        *buffer = *uart_rx_readPT;
        uart_rx_readPT++; buffer++;
        if(uart_rx_readPT >= &uart_rx_buffer[UART_BUFFER_SIZE]) 
            {
                uart_rx_readPT = uart_rx_buffer;
            }
        
        uart_msg--;
        return uart_msg;
     }

return -1;
}
    

#if defined(__ARMCC_VERSION)
    
/* For MDK/RVDS compiler revise fputc function for printf functionality */
struct __FILE 
{
    int handle;  
};
 
enum 
{
    STDIN_HANDLE,
    STDOUT_HANDLE,
    STDERR_HANDLE
};
 
FILE __stdin = {STDIN_HANDLE};
FILE __stdout = {STDOUT_HANDLE};
FILE __stderr = {STDERR_HANDLE};
 
int fputc(int ch, FILE *file) 
{
    int ret = EOF;
 
    switch( file->handle )
    {
        case STDOUT_HANDLE:
            UART_UartPutChar(ch);
            ret = ch ;
            break ;
 
        case STDERR_HANDLE:
            ret = ch ;
            break ;
 
        default:
            file = file;
            break ;
    }
    return ret ;
}
 
#elif defined (__ICCARM__)      /* IAR */
 
/* For IAR compiler revise __write() function for printf functionality */
size_t __write(int handle, const unsigned char * buffer, size_t size)
{
    size_t nChars = 0;
 
    if (buffer == 0)
    {
        /*
         * This means that we should flush internal buffers.  Since we
         * don't we just return.  (Remember, "handle" == -1 means that all
         * handles should be flushed.)
         */
        return (0);
    }
 
    for (/* Empty */; size != 0; --size)
    {
        UART_UartPutChar(*buffer++);
        ++nChars;
    }
 
    return (nChars);
}
 
#else  /* (__GNUC__)  GCC */
 
/* For GCC compiler revise _write() function for printf functionality */
int _write(int file, char *ptr, int len)
{
    int i;
    file = file;
    for (i = 0; i < len; i++)
    {
        UART_PutChar(*ptr++);
        //UART_UartPutChar
    }
    return len;
}
 
 
#endif  /* (__ARMCC_VERSION) */   
/* [] END OF FILE */
